Index: branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4015)
+++ branches/2013/dev_r3940_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 4064)
@@ -682,63 +891,49 @@
                   ENDDO   
 
-                  DO ji = nistr, niend, nn_factx
-                     DO jj = njstr, njend, nn_facty
-                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                        ijje = mje_crs(ij)
-                        ijie = mie_crs(ii)                  
-                        !
-                        zflcrs  =   p_fld(ji  ,jj  ,1) * zsurf(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1) &
-                           &      + p_fld(ji+1,jj  ,1) * zsurf(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1) &
-                           &      + p_fld(ji+2,jj  ,1) * zsurf(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1) &
-                           &      + p_fld(ji  ,jj+1,1) * zsurf(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1) &
-                           &      + p_fld(ji+1,jj+1,1) * zsurf(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1) &
-                           &      + p_fld(ji+2,jj+1,1) * zsurf(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1) &
-                           &      + p_fld(ji  ,jj+2,1) * zsurf(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1) &
-                           &      + p_fld(ji+1,jj+2,1) * zsurf(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1) &
-                           &      + p_fld(ji+2,jj+2,1) * zsurf(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) 
-                        !
-                        p_fld_crs(ii,ij,1) = zflcrs
-                        !
-                     ENDDO      
-                  ENDDO
-           
-               CASE( 'V' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)
-                           !                  
-                           zflcrs  =  p_fld(ji  ,ijje,jk) * zsurf(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) &
-                             &      + p_fld(ji+1,ijje,jk) * zsurf(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) &
-                             &      + p_fld(ji+2,ijje,jk) * zsurf(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) 
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs
-                           !
-                         ENDDO      
-                     ENDDO
-                  ENDDO   
-
             
                CASE( 'U' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
+
+                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+                        je_2 = mje_crs(2)
+                        DO jk = 1, jpk           
+                           DO ji = nistr, niend, nn_factx
+                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2  
+                              ijie = mie_crs(ii)
+                              zflcrs = p_fld(ijie,je_2,jk) * p_mask(ijie,je_2,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf 
+                              !
+                              p_fld_crs(ii,2,jk) = zflcrs
+                            ENDDO
+                        ENDDO
+                      ENDIF
+                  ELSE
+                     je_2 = mjs_crs(2)
+                     DO jk = 1, jpk           
+                        DO ji = nistr, niend, nn_factx
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
+                           ijie = mie_crs(ii)
+                           zflcrs = &
+                             & MAX( p_fld(ijie,je_2  ,jk) * p_mask(ijie,je_2  ,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,je_2+1,jk) * p_mask(ijie,je_2+1,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,je_2+2,jk) * p_mask(ijie,je_2+2,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf  )
+                            !
+                           p_fld_crs(ii,2,jk) = zflcrs
+                        ENDDO
+                     ENDDO
+                  ENDIF
+                  !
+                  DO jk = 1, jpk           
+                     DO jj  = njstr, njend, nn_facty
+                        DO ji = nistr, niend, nn_factx
                            ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
+                           ij   = ( jj - njstr ) * rfacty_r + 3
                            ijie = mie_crs(ii)
-                           !                  
-                           zflcrs =  p_fld(ijie,jj  ,jk) * zsurf(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk) &
-                             &     + p_fld(ijie,jj+1,jk) * zsurf(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) &
-                             &     + p_fld(ijie,jj+2,jk) * zsurf(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk)
-                           !
+                           zflcrs =  &
+                             & MAX( p_fld(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk) - ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) - ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) - ( 1.- p_mask(ijie,jj,jk) ) * r_inf  )
+                           ! 
                            p_fld_crs(ii,ij,jk) = zflcrs
-                           !
+                           ! 
                         ENDDO      
                      ENDDO
@@ -747,33 +942,77 @@
               END SELECT
 
-              IF( PRESENT( p_surf_crs ) ) THEN
-                 WHERE ( p_surf_crs /= 0.0 ) p_fld_crs(:,:,:) = p_fld_crs(:,:,:) / p_surf_crs(:,:,:)
-              ENDIF
-
-              CALL wrk_dealloc( jpi, jpj, jpk, zsurf )
-
-         CASE ( 'MAX' )
+              CALL wrk_dealloc( jpi, jpj, jpk, zmask )
+
+         CASE ( 'MIN' )      !   Search the min of unmasked grid cells
+
+            CALL wrk_alloc( jpi, jpj, jpk, zmask )
+
+            SELECT CASE ( cd_type )
+              CASE( 'W' )
+                  zmask(:,:,1) = p_mask(:,:,1) 
+                  DO jk = 2, jpk
+                     zmask(:,:,jk) = p_mask(:,:,jk-1) 
+                  ENDDO
+              CASE ( 'T' )
+                  DO jk = 1, jpk
+                     zmask(:,:,jk) = p_mask(:,:,jk) 
+                  ENDDO
+            END SELECT
+
+            SELECT CASE ( cd_type )
+
+               CASE( 'T', 'W' )
          
-            SELECT CASE ( cd_type )
-            
-               CASE( 'T' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)                  
- 
-                           zflcrs =  MAX( p_fld(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
-                             &            p_fld(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
-                             &            p_fld(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
-                             &            p_fld(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk),  &
-                             &            p_fld(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk),  &
-                             &            p_fld(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
-                             &            p_fld(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
-                             &            p_fld(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
-                             &            p_fld(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk)   )
+                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+                        je_2 = mje_crs(2)
+                        DO jk = 1, jpk           
+                           DO ji = nistr, niend, nn_factx
+                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2        
+                              zflcrs =  &
+                                & MIN( p_fld(ji  ,je_2,jk) * zmask(ji  ,je_2,jk) + ( 1.- zmask(ji  ,je_2,jk) ) * r_inf ,  &
+                                &      p_fld(ji+1,je_2,jk) * zmask(ji+1,je_2,jk) + ( 1.- zmask(ji+1,je_2,jk) ) * r_inf ,  &
+                                &      p_fld(ji+2,je_2,jk) * zmask(ji+2,je_2,jk) + ( 1.- zmask(ji+2,je_2,jk) ) * r_inf  )
+                              !
+                              p_fld_crs(ii,2,jk) = zflcrs
+                           ENDDO
+                        ENDDO
+                      ENDIF
+                  ELSE
+                     je_2 = mjs_crs(2)
+                     DO jk = 1, jpk           
+                        DO ji = nistr, niend, nn_factx
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
+                           zflcrs =  &
+                             & MIN( p_fld(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk) + ( 1.- zmask(ji  ,je_2  ,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk) + ( 1.- zmask(ji+1,je_2  ,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk) + ( 1.- zmask(ji+2,je_2  ,jk) ) * r_inf ,  &
+                             &      p_fld(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk) + ( 1.- zmask(ji  ,je_2+1,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk) + ( 1.- zmask(ji+1,je_2+1,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk) + ( 1.- zmask(ji+2,je_2+1,jk) ) * r_inf ,  &
+                             &      p_fld(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk) + ( 1.- zmask(ji  ,je_2+2,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk) + ( 1.- zmask(ji+1,je_2+2,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk) + ( 1.- zmask(ji+2,je_2+2,jk) ) * r_inf   )
+                           !
+                           p_fld_crs(ii,2,jk) = zflcrs
+                        ENDDO
+                     ENDDO
+                  ENDIF
+                  !
+                  DO jk = 1, jpk           
+                     DO jj  = njstr, njend, nn_facty
+                        DO ji = nistr, niend, nn_factx
+                           ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                           ij  = ( jj - njstr ) * rfacty_r + 3
+                           zflcrs =  &
+                             & MIN( p_fld(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk) + ( 1.- zmask(ji  ,jj  ,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk) + ( 1.- zmask(ji+1,jj  ,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk) + ( 1.- zmask(ji+2,jj  ,jk) ) * r_inf ,  &
+                             &      p_fld(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk) + ( 1.- zmask(ji  ,jj+1,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk) + ( 1.- zmask(ji+1,jj+1,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk) + ( 1.- zmask(ji+2,jj+1,jk) ) * r_inf ,  &
+                             &      p_fld(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk) + ( 1.- zmask(ji  ,jj+2,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk) + ( 1.- zmask(ji+1,jj+2,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk) + ( 1.- zmask(ji+2,jj+2,jk) ) * r_inf   )
                            !
                            p_fld_crs(ii,ij,jk) = zflcrs
@@ -783,23 +1022,36 @@
                   ENDDO   
             
-               CASE( 'W' )
-         
-                  DO jk = 2, jpk
+               CASE( 'V' )
+
+                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+                        ijje = mje_crs(2)
+                      ENDIF
+                  ELSE
+                     ijje = mjs_crs(2)
+                  ENDIF
+
+                  DO jk = 1, jpk
                      DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        zflcrs = &
+                          & MIN( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
+                          &      p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
+                          &      p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf )
+                          !
+                        p_fld_crs(ii,2,jk) = zflcrs
+                     ENDDO
+                  ENDDO
+                  !
+                  DO jk = 1, jpk           
+                     DO jj  = njstr, njend, nn_facty
+                        DO ji = nistr, niend, nn_factx
+                           ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
+                           ij  = ( jj - njstr ) * rfacty_r + 3
                            ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)
-                           !                  
-                           zflcrs =  MAX( p_fld(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1),  &
-                             &            p_fld(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1),  &
-                             &            p_fld(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1),  &
-                             &            p_fld(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1),  &
-                             &            p_fld(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1),  &
-                             &            p_fld(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1),  &
-                             &            p_fld(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1),  &
-                             &            p_fld(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1),  &
-                             &            p_fld(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) )
+                           zflcrs = &
+                             & MIN( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
+                             &      p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
+                             &      p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf )
                            !
                            p_fld_crs(ii,ij,jk) = zflcrs
@@ -809,196 +1061,64 @@
                   ENDDO   
 
-                  DO ji = nistr, niend, nn_factx
-                     DO jj = njstr, njend, nn_facty
-                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                        ijje = mje_crs(ij)
-                        ijie = mie_crs(ii)                  
-                        !
-                        zflcrs = MAX( p_fld(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1),  &
-                           &          p_fld(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1),  &
-                           &          p_fld(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1),  &
-                           &          p_fld(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1),  &
-                           &          p_fld(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1),  &
-                           &          p_fld(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1),  &
-                           &          p_fld(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1),  &
-                           &          p_fld(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1),  &
-                           &          p_fld(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1)  ) 
-                         !
-                         p_fld_crs(ii,ij,1) = zflcrs
-                         !
-                     ENDDO      
-                  ENDDO
-           
-               CASE( 'V' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
+            
+               CASE( 'U' )
+
+                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+                        je_2 = mje_crs(2)
+                        DO jk = 1, jpk           
+                           DO ji = nistr, niend, nn_factx
+                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2  
+                              ijie = mie_crs(ii)
+                              zflcrs = p_fld(ijie,je_2,jk) * p_mask(ijie,je_2,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf 
+                              !
+                              p_fld_crs(ii,2,jk) = zflcrs
+                            ENDDO
+                        ENDDO
+                      ENDIF
+                  ELSE
+                     je_2 = mjs_crs(2)
+                     DO jk = 1, jpk           
+                        DO ji = nistr, niend, nn_factx
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
+                           ijie = mie_crs(ii)
+                           zflcrs = &
+                             & MIN( p_fld(ijie,je_2  ,jk) * p_mask(ijie,je_2  ,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,je_2+1,jk) * p_mask(ijie,je_2+1,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,je_2+2,jk) * p_mask(ijie,je_2+2,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf  )
+                            !
+                           p_fld_crs(ii,2,jk) = zflcrs
+                        ENDDO
+                     ENDDO
+                  ENDIF
+                  !
+                  DO jk = 1, jpk           
+                     DO jj  = njstr, njend, nn_facty
+                        DO ji = nistr, niend, nn_factx
                            ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
+                           ij   = ( jj - njstr ) * rfacty_r + 3
                            ijie = mie_crs(ii)
-                           !                  
-                           zflcrs = MAX( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk),  &
-                             &           p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk),  &
-                             &           p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) )
-                           !
+                           zflcrs = &
+                             & MIN( p_fld(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk) + ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) + ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
+                             &      p_fld(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) + ( 1.- p_mask(ijie,jj,jk) ) * r_inf  )
+                           ! 
                            p_fld_crs(ii,ij,jk) = zflcrs
-                           !
+                           ! 
                         ENDDO      
                      ENDDO
                   ENDDO   
-
-            
-               CASE( 'U' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)
-                           !                  
-                           Zflcrs = MAX( p_fld(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk),  &
-                             &           p_fld(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk),  &
-                             &           p_fld(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO   
-
-              END SELECT
-
-         CASE ( 'MIN' )
-            !   Search the min of masked grid cells
-            SELECT CASE ( cd_type )
-            
-               CASE( 'T' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)                  
-                           
-                           zflcrs =  MIN( p_fld(ji  ,jj  ,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk) ) * zeps ),  &
-                             &            p_fld(ji+1,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+1,jj  ,jk) ) * zeps ),  &
-                             &            p_fld(ji+2,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+2,jj  ,jk) ) * zeps ),  &
-                             &            p_fld(ji  ,jj+1,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk) ) * zeps ),  &
-                             &            p_fld(ji+1,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk) ) * zeps ),  &
-                             &            p_fld(ji+2,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk) ) * zeps ),  &
-                             &            p_fld(ji  ,jj+2,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk) ) * zeps ),  &
-                             &            p_fld(ji+1,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk) ) * zeps ),  &
-                             &            p_fld(ji+2,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk) ) * zeps )   )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO   
-           
-               CASE( 'W' )
-         
-                  DO jk = 2, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)                  
-                           
-                           zflcrs =  MIN( p_fld(ji  ,jj  ,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk-1) ) * zeps ),  &
-                             &            p_fld(ji+1,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+1,jj  ,jk-1) ) * zeps ),  &
-                             &            p_fld(ji+2,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+2,jj  ,jk-1) ) * zeps ),  &
-                             &            p_fld(ji  ,jj+1,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk-1) ) * zeps ),  &
-                             &            p_fld(ji+1,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk-1) ) * zeps ),  &
-                             &            p_fld(ji+2,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk-1) ) * zeps ),  &
-                             &            p_fld(ji  ,jj+2,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk-1) ) * zeps ),  &
-                             &            p_fld(ji+1,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk-1) ) * zeps ),  &
-                             &            p_fld(ji+2,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk-1) ) * zeps )   )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO  
- 
-                  DO ji = nistr, niend, nn_factx
-                     DO jj = njstr, njend, nn_facty
-                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                        ijje = mje_crs(ij)
-                        ijie = mie_crs(ii)                  
-                        
-                        zflcrs =  MIN( p_fld(ji  ,jj  ,1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
-                          &            p_fld(ji+1,jj  ,1) * ( 1. + ( 1. - p_mask(ji+1,jj  ,1) ) * zeps ),  &
-                          &            p_fld(ji+2,jj  ,1) * ( 1. + ( 1. - p_mask(ji+2,jj  ,1) ) * zeps ),  &
-                          &            p_fld(ji  ,jj+1,1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
-                          &            p_fld(ji+1,jj+1,1) * ( 1. + ( 1. - p_mask(ji+1,jj+1,1) ) * zeps ),  &
-                          &            p_fld(ji+2,jj+1,1) * ( 1. + ( 1. - p_mask(ji+2,jj+2,1) ) * zeps ),  &
-                          &            p_fld(ji  ,jj+2,1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
-                          &            p_fld(ji+1,jj+2,1) * ( 1. + ( 1. - p_mask(ji+1,jj+1,1) ) * zeps ),  &
-                          &            p_fld(ji+2,jj+2,1) * ( 1. + ( 1. - p_mask(ji+2,jj+2,1) ) * zeps )   )
-                        !
-                        p_fld_crs(ii,ij,1) = zflcrs * p_mask_crs(ii,ij,1)
-                        !
-                     ENDDO      
-                  ENDDO
-
-               CASE( 'V' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)                  
-                           
-                           zflcrs =  MIN( p_fld(ji  ,ijje,jk) * ( 1. + ( 1. - p_mask(ji  ,ijje,jk) ) * zeps ),  &
-                             &            p_fld(ji+1,ijje,jk) * ( 1. + ( 1. - p_mask(ji+1,ijje,jk) ) * zeps ),  &
-                             &            p_fld(ji+2,ijje,jk) * ( 1. + ( 1. - p_mask(ji+2,ijje,jk) ) * zeps )   )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO  
-
-
-               CASE( 'U' )
-         
-                  DO jk = 1, jpk
-                     DO ji = nistr, niend, nn_factx
-                        DO jj = njstr, njend, nn_facty
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
-                           ijje = mje_crs(ij)
-                           ijie = mie_crs(ii)                  
-                           
-                           zflcrs =  MIN( p_fld(ijie,jj  ,jk) * ( 1. + ( 1. - p_mask(ijie,jj  ,jk) ) * zeps ),  &
-                             &            p_fld(ijie,jj+1,jk) * ( 1. + ( 1. - p_mask(ijie,jj+1,jk) ) * zeps ),  &
-                             &            p_fld(ijie,jj+2,jk) * ( 1. + ( 1. - p_mask(ijie,jj+2,jk) ) * zeps )   )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO  
+          
             END SELECT
+            !
+            CALL wrk_dealloc( jpi, jpj, jpk, zmask )
             !
          END SELECT
          !
-         CALL crs_lbc_lnk( p_fld_crs, cd_type, 1.0 )
+         CALL crs_lbc_lnk( p_fld_crs, cd_type, psgn )
          !
     END SUBROUTINE crs_dom_ope_3d
 
-    SUBROUTINE crs_dom_ope_2d( p_fld, cd_op, cd_type, p_mask, p_fld_crs, p_e12, p_e3, p_surf_crs, p_mask_crs )
+    SUBROUTINE crs_dom_ope_2d( p_fld, cd_op, cd_type, p_mask, p_fld_crs, p_e12, p_e3, p_surf_crs, p_mask_crs, psgn )
       !!----------------------------------------------------------------
       !!               *** SUBROUTINE crsfun_UV ***
@@ -1033,4 +1153,5 @@
       REAL(wp), DIMENSION(jpi_crs,jpj_crs)    , INTENT(in), OPTIONAL :: p_surf_crs ! Coarse grid area-weighting denominator    
       REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_mask_crs    ! Coarse grid T,U,V mask
+      REAL(wp),                                 INTENT(in)           :: psgn   
 
       REAL(wp), DIMENSION(jpi_crs,jpj_crs)    , INTENT(out)          :: p_fld_crs ! Coarse grid box 3D quantity 
